/*
   Copyright (C) 1996 Nils Schmeisser FVTK, FZ-Rossendorf

This file is part of xwho.

xwho is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

xwho is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with xwho; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <utmp.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "xapp.h"

int MAXUSERS=1024;
typedef char char64[64];
Widget *wu;
Widget sysinfo;
char64* user;
Widget list;
int nuser;

Display *dpy;
XtAppContext ctx;
Widget topshell;

extern void gethostname(char *name,int namelen);

void getusers() {
  struct utmp who;
  char u[9],h[17],l[9],s[256];
  FILE *f;
  char host[256];
  XmString xms;
  int result,i;
  int *el,ne;

  for (i=0;i<nuser;i++) {
    XmListDeletePos(list,0);
  }
  nuser=0;
  f=fopen("/etc/utmp","r");
  if (f!=NULL) {
    result=1;
    while (result!=0) {
      result=fread(&who,sizeof(struct utmp),1,f);
      if ((result!=0) && (who.ut_time>0) && (who.ut_name[0]>0x20)) {
	strncpy(u,(char*)(&who.ut_name[0]),8);
	u[8]=0;
	strncpy(h,(char*)(&who.ut_host[0]),16);
	h[16]=0;
	strncpy(l,(char*)(&who.ut_line[0]),8);
	l[8]=0;
	sprintf(user[nuser],"%-8s from %-16s on %-8s",u,h,l);
	nuser++;
      }
    }
    qsort(user,nuser,64,(int(*)(const void*,const void*))strcmp);
    for (i=0;i<nuser;i++) {
      xms=XmStringCreate(user[i],XmSTRING_DEFAULT_CHARSET);
      XmListAddItem(list,xms,0);
    }
  }
  sprintf(s,"Host: %s, currently %d users on",getenv("HOST"),nuser);
  xSetLabel(sysinfo,s);
  fclose(f);
}

void about(Widget,caddr_t,caddr_t) {
  xCreateMessageBox("About X-Who V 1.0","
(C) Nils Schmeisser\n
FVTK, FZ Rossendorf, 1996\n
This software is restricted\n
by the GNU General Public License.\n
\n
X-Who displays the currently\n
logged in users.\n
Userinfo brings up information\n
about a selected user. For\n
update press the Update-button.\n
This version is restricted to\n
maximum 1024 logged in users.\n
\n
",topshell);
}

void pstat(Widget,caddr_t,caddr_t) {
  system("xterm -sb -title ProcessStatus -e ps.bat");
}

void userinfo(Widget,caddr_t,caddr_t) {
  int *el=new int [nuser];
  int en;
  char s[256],u[10];

  XmListGetSelectedPos(list,&el,&en);
  if (en>0) {
    sscanf(user[el[0]-1],"%s",u);
    sprintf(s,"xterm -sb -title Userinfo -e xwho.bat %s",u);
    system(s);
    /*
       
       finger -ph username
       cat .project
       cat .plan
       USER       PID %CPU %MEM   SZ  RSS TT  STAT   TIME COMMAND
       ps -au | grep $username

    */
  }
}

void run(Widget,caddr_t,caddr_t) {
  getusers();
}

int main(int argc,char **argv) {
  int i;
  Widget d,c,rc,rcb;
  char s[256];
  Arg args[3];

  topshell=xInitApplication("xwho",&dpy,&ctx,argc,argv);
  
  nuser=0;
  user=new char64 [MAXUSERS];
  d=xCreatePopupShell("X-Who",10,10,500,500,topshell);
    rc=xCreateRowColumn(XmVERTICAL,d);
      rcb=xCreateRowColumn(XmHORIZONTAL,rc);
        xCreatePushButton("Update",kbNO,(XtCallbackProc)run,rcb);
        xCreatePushButton("Userinfo",kbNO,(XtCallbackProc)userinfo,rcb);
        xCreatePushButton("Processes",kbNO,(XtCallbackProc)pstat,rcb);
        xCreatePushButton("About",kbNO,(XtCallbackProc)about,rcb);
    sprintf(s,"Host: %s, currently %d users on","",0);
    sysinfo=xCreateLabel(s,rc);
    list=xCreateScrolledList(20,rc);
    i=0;
    XtSetArg(args[i],XmNselectionPolicy,XmSINGLE_SELECT); i++;
    XtSetValues(list,args,i);
  xPopup(d);
  run(list,NULL,NULL);

  XtAppMainLoop(ctx);

  return 0;
}

